package net.croz.nrich.formconfiguration.service;

import lombok.RequiredArgsConstructor;
import net.croz.nrich.formconfiguration.api.model.ConstrainedProperty;
import net.croz.nrich.formconfiguration.api.model.ConstrainedPropertyClientValidatorConfiguration;
import net.croz.nrich.formconfiguration.api.service.ConstrainedPropertyValidatorConverterService;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.core.annotation.Order;

import java.util.Collections;
import java.util.List;

@RequiredArgsConstructor
@Order
public class DefaultConstrainedPropertyValidatorConverterService implements ConstrainedPropertyValidatorConverterService {

    private final FieldErrorMessageResolverService fieldErrorMessageResolverService;

    @Override
    public List<ConstrainedPropertyClientValidatorConfiguration> convert(final ConstrainedProperty constrainedProperty) {
        final String message = fieldErrorMessageResolverService.resolveErrorMessage(constrainedProperty, LocaleContextHolder.getLocale());
        final ConstrainedPropertyClientValidatorConfiguration validator = new ConstrainedPropertyClientValidatorConfiguration(constrainedProperty.getType(), constrainedProperty.getConstraintName(), constrainedProperty.getConstraintArgumentMap(), message);

        return Collections.singletonList(validator);
    }

    @Override
    public boolean supports(final ConstrainedProperty constrainedProperty) {
        return true;
    }
}
